/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/* --- BBS: www.STCAIMCU.com  -----------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ        */
/*---------------------------------------------------------------------*/

#include "ai8h.h"
#include "uart.h"
#include "usb.h"
#include "util.h"
#include "usb_req_class.h"
#include "config.h"
//#include "math.h"				//ѧ
//#include "string.h"				//ַ鴦Ҫͷļ
#include "intrins.h"			//CPU_nop_()
//#include "stdio.h" 				//printf

BOOL UartBusy;


void uart_init()
{
//    P_SW2 &= ~0x01;     //UART2 switch to: 0: P1.0 P1.1

    P1M0 &= ~0x03;      //P1.0,P1.1Ϊ׼˫ģʽ
    P1M1 &= ~0x03;

    S2CON = 0x50;
    T2L = BR(115200);
    T2H = BR(115200) >> 8;
    AUXR |= 0x14;	      //ʱ2ʱ1Tģʽ,ʼʱ
    IE2  |= 1;            //ж

    LineCoding.dwDTERate = REV4(115200);
    LineCoding.bCharFormat = 0;
    LineCoding.bParityType = 0;
    LineCoding.bDataBits = 8;
}

void uart2_isr() interrupt UART2_VECTOR
{
    if((S2CON & 2) != 0)
    {
        S2CON &= ~2;    //Clear Tx flag
        UartBusy = 0;
    }

    if((S2CON & 1) != 0)
    {
        S2CON &= ~1;    //Clear Rx flag
        TxBuffer[TxWptr++] = S2BUF;
    }
}

void uart_set_parity(BYTE parity)
{
    switch (parity)
    {
    case NONE_PARITY:
        S2CON = 0x50;
        break;
    case ODD_PARITY:
    case EVEN_PARITY:
    case MARK_PARITY:
        S2CON = 0xda;
        break;
    case SPACE_PARITY:
        S2CON = 0xd2;
        break;
    }
}

void uart_set_baud(DWORD baud)
{
    WORD temp;

    temp = (WORD)BR(baud);
    T2L = temp;
    T2H = temp >> 8;
}

//// ԭⲻش
//void uart_polling()
//{
//    BYTE cnt;

//    if (DeviceState != DEVSTATE_CONFIGURED)
//        return;

//    if(!UsbInBusy_CDC && (RxRptr != RxWptr))		//յ
//    {			
//        IE2 &= ~0x80;   //EUSB = 0;
//        UsbInBusy_CDC = 1;
//        usb_write_reg(INDEX, 3);
//        cnt = 0;
//        while (RxRptr != RxWptr)
//        {
//            usb_write_reg(FIFO3, RxBuffer[RxRptr++]);
//            cnt++;
//            if (cnt == EP1IN_SIZE) break;
//        }
//        usb_write_reg(INCSR1, INIPRDY);
//        IE2 |= 0x80;    //EUSB = 1;		
//	}
//	
//    if (UsbOutBusy_CDC)
//    {
//        IE2 &= ~0x80;   //EUSB = 0;
//        if (RxWptr - RxRptr < 256 - EP1OUT_SIZE)
//        {
//            UsbOutBusy_CDC = 0;
//            usb_write_reg(INDEX, 3);
//            usb_write_reg(OUTCSR1, 0);
//        }
//        IE2 |= 0x80;    //EUSB = 1;
//    }
//}

void usb_send_cdc_byte(char byt)
{
	if (DeviceState != DEVSTATE_CONFIGURED)
        return;
	
	if(!UsbInBusy_CDC)
	{			
		IE2 &= ~0x80;   //EUSB = 0;
		UsbInBusy_CDC = 1;
		usb_write_reg(INDEX, 4);
		
		usb_write_reg(FIFO4, byt);
		
		usb_write_reg(INCSR1, INIPRDY);
		IE2 |= 0x80;    //EUSB = 1;		
	}
	
	if (UsbOutBusy_CDC)
	{
		IE2 &= ~0x80;   //EUSB = 0;
			UsbOutBusy_CDC = 0;
			usb_write_reg(INDEX, 4);
			usb_write_reg(OUTCSR1, 0);
		IE2 |= 0x80;    //EUSB = 1;
	}
	
	delay_ms(1);//ʱֹճ
}

// USB-CDC ַ
void usb_send_cdc_str(char *str)
{
	u8 i;

	if (DeviceState != DEVSTATE_CONFIGURED)
        return;
	
	if(!UsbInBusy_CDC)
	{			
		IE2 &= ~0x80;   //EUSB = 0;
		UsbInBusy_CDC = 1;
		usb_write_reg(INDEX, 4);
		for(i=0;i<getStrLength(str);i++)
		{
			usb_write_reg(FIFO4, str[i]);
		}
		usb_write_reg(INCSR1, INIPRDY);
		IE2 |= 0x80;    //EUSB = 1;
	}
	
	if (UsbOutBusy_CDC)
	{
		IE2 &= ~0x80;   //EUSB = 0;
			UsbOutBusy_CDC = 0;
			usb_write_reg(INDEX, 4);
			usb_write_reg(OUTCSR1, 0);
		IE2 |= 0x80;    //EUSB = 1;
	}
	
	delay_ms(1);//ʱֹճ
}


// USB-CDC תһַ
void usb_send_cdc_num(char *str1, u16 num, char *str2)
{
	u8 i,len,cnt;
	char dat[24];
	
	// str1 ȣת浽 dat 
	for(i=0;i<getStrLength(str1);i++)
	{
		dat[i] = str1[i];
	}
	cnt = i;
	
	// num ȣת浽 dat 
	len = getIntLength(num);
	for(i=0;i<len;i++){
//		dat[i] = num / pow(10,len-1-i) + 0x30;
//		num = num - (dat[i] - 0x30) * pow(10,len-1-i);//ѧ׹		
		dat[cnt + len - i -1] = num % 10 + 0x30;//ȡֵ
		num = num/10;
	}
	cnt += i;

	// str1 ȣת浽 dat 
	for(i=0;i<getStrLength(str2);i++)
	{
		dat[cnt + i] = str2[i];
	}
	cnt += i;
	
	dat[cnt++] = '\r';
	dat[cnt++] = '\n';
	dat[cnt] = '\0';//Ҫӽ鲻
	
	usb_send_cdc_str(dat);//datǰܼ&ܴ׵ַ
}


